/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  File-exist and directory-searching routines                            *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include <dos.h>
#include <stdlib.h>
#include <string.h>
#include "ffind.h"
#include "prog.h"

/*
main()
{
  printf("asdfe=%d\n",direxist("c:\\asdfe"));
  printf("blank=%d\n",direxist("c:\\blank"));
  printf("tc=%d\n",direxist("c:\\tc"));
  printf("c:\\=%d\n",direxist("c:\\"));
  printf("d:\\=%d\n",direxist("d:\\"));
  printf("e:\\=%d\n",direxist("e:\\"));
  printf("f:\\=%d\n",direxist("f:\\"));
}
*/


int fexist(char *filename)
{
  FFIND *ff;

  ff=FindOpen(filename,0);

  if (ff)
  {
    FindClose(ff);
    return TRUE;
  }
  else return FALSE;
}

long fsize(char *filename)
{
  FFIND *ff;
  long ret=-1L;

  ff=FindOpen(filename,0);

  if (ff)
  {
    ret=ff->ff_fsize;
    FindClose(ff);
  }

  return ret;
}

int direxist(char *directory)
{
  FFIND *ff;

  int x;

  char *tempstr;

  if ((tempstr=(char *)malloc(strlen(directory)+5))==NULL)
    return FALSE;

  strcpy(tempstr,directory);

  /* add a backslash, then iff there is two at the end, remove one of 'em */
  /* this works good for msdos, and for UNC path names. */
  strcat(tempstr, "\\");

  if ((tempstr[(x=strlen(tempstr))-1]=='\\' || tempstr[x-1]=='/') &&
      (tempstr[x-2]=='\\' || tempstr[x-2]=='/'))
    tempstr[x-1]='\0';

  /* Root directory of any drive always exists! */

  if (isalpha(tempstr[0]) && tempstr[1]==':' &&
      (tempstr[2]=='\\' || tempstr[2]=='/') && !tempstr[3])
  {
    free(tempstr);
    return TRUE;
  }


  strcat(tempstr, "*.*");

  ff=FindOpen(tempstr,MSDOS_subdir | MSDOS_hidden | MSDOS_readonly | MSDOS_system);

  if (ff)
  {
    FindClose(ff);
    free(tempstr);
    return TRUE;
  }

  free(tempstr);
  return FALSE;
}

